#include <algorithm>
#include <map>
#include <regex>

#include "morse.h"

std::map<char, std::string> morseCode = {
    {'A', ".-"},     {'B', "-..."},    {'C', "-.-."},   {'D', "-.."},    {'E', "."},      {'F', "..-."},
    {'G', "--."},    {'H', "...."},    {'I', ".."},     {'J', ".---"},   {'K', "-.-"},    {'L', ".-.."},
    {'M', "--"},     {'N', "-."},      {'O', "---"},    {'P', ".--."},   {'Q', "--.-"},   {'R', ".-."},
    {'S', "..."},    {'T', "-"},       {'U', "..-"},    {'V', "...-"},   {'W', ".--"},    {'X', "-..-"},
    {'Y', "-.--"},   {'Z', "--.."},    {'1', ".----"},  {'2', "..---"},  {'3', "...--"},  {'4', "....-"},
    {'5', "....."},  {'6', "-...."},   {'7', "--..."},  {'8', "---.."},  {'9', "----."},  {'0', "-----"},
    {',', "--..--"}, {'.', ".-.-.-"},  {'?', "..--.."}, {'/', "-..-."},  {'-', "-....-"}, {':', "---..."},
    {'&', ".-..."},  {'\'', ".----."}, {'@', ".--.-."}, {')', "-.--.-"}, {'(', "-.--."},  {'\"', ".-..-."},
    {'=', "-...-"},  // '=' == <BT>
    {'k', "-.--."},  // k == <KN>
    {'s', "...-.-"}, // s == <SK>
    {'+', ".-.-."},  // + == <AR>
    {'a', "-.-.-"},  // a == <KA>
};

void refurbishMessage(std::string &msg)
{
    printf("The message is: %s\n", msg.c_str());
    //std::string msgRefurb;
    //msgRefurb.resize(msg.size());

    // Make the message all upper case
    //std::transform(msg.begin(), msg.end(), msgRefurb.begin(), [](unsigned char c) { return std::toupper(c); });
    std::transform(msg.begin(), msg.end(), msg.begin(), ::toupper);


    // Encode the special characters as we like it
    //msg = std::regex_replace(msg, std::regex("<BT>"), "=");
    //msg = std::regex_replace(msg, std::regex("<KN>"), "k");
    //msg = std::regex_replace(msg, std::regex("<SK>"), "s");
    //msg = std::regex_replace(msg, std::regex("<AR>"), "+");
    //msg = std::regex_replace(msg, std::regex("<KA>"), "a");

    //printf("Msg Origgg: %s\n", msg.c_str());

    // Remove all other unknown characters
    //msg.erase(remove_if(msg.begin(), msg.end(),
    //                          [](const char &c) { return c != ' ' && morseCode.find(c) == morseCode.end(); }),
    //                msg.end());

    // Remove spaces, if there are too many of them
    //msg = std::regex_replace(msg, std::regex("(\\s+)"), " ");

    //printf("Msg Origgg2: %s\n", msg.c_str());
    //return msgRefurb;
}

std::string messageToMorse(std::string &msg)
{
    refurbishMessage(msg);
    
    std::string morseString = "";

    printf("Ref Mesg (%i): %s\n", msg.length(), msg.c_str());

    for (unsigned int i = 0; i < msg.length(); i++) {
        char c = msg[i];
        if (c == ' ') {
            morseString += 'w';
            continue;
        }

        // Ignore and continue with next char, if not found
        auto search = morseCode.find(c);
        if (search == morseCode.end()) {
            printf("Nanu (i=%i)? %c\n", i, c);
            continue;
        }

        for (unsigned int j = 0; j < morseCode[c].length(); j++) {
            char  m = morseCode[c][j]; printf("M = %c\n", m);
            if (j == 0 && i > 0 && msg[i - 1] != ' ') {
                morseString += 'c';
            }

            morseString += m;

            if (j < morseCode[c].length() - 1) {
                morseString += 'i';
            }
        }
    }

    // Append word space if last char was not a blank
    if (msg.back() != ' ') {
        morseString += 'w';
    }

    printf("Sodele: %s\n", morseString.c_str());
    printf("Ref Mesg 2 (%i): %s\n", msg.length(), msg.c_str());

    return morseString;
}